HttpWhiteboardConstants
Date: 2016-06-25

org.osgi.service.http.whiteboard

## Class HttpWhiteboardConstants

- java.lang.Object
- - org.osgi.service.http.whiteboard.HttpWhiteboardConstants

-     public final class HttpWhiteboardConstants
      extends java.lang.Object

  Defines standard constants for the Http Whiteboard services.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `DISPATCHER_ASYNC` Possible value for the `HTTP_WHITEBOARD_FILTER_DISPATCHER` property indicating the servlet filter is applied in the asynchronous context.
    `static java.lang.String` | `DISPATCHER_ERROR` Possible value for the `HTTP_WHITEBOARD_FILTER_DISPATCHER` property indicating the servlet filter is applied when an error page is called.
    `static java.lang.String` | `DISPATCHER_FORWARD` Possible value for the `HTTP_WHITEBOARD_FILTER_DISPATCHER` property indicating the servlet filter is applied to forward calls to the dispatcher.
    `static java.lang.String` | `DISPATCHER_INCLUDE` Possible value for the `HTTP_WHITEBOARD_FILTER_DISPATCHER` property indicating the servlet filter is applied to include calls to the dispatcher.
    `static java.lang.String` | `DISPATCHER_REQUEST` Possible value for the `HTTP_WHITEBOARD_FILTER_DISPATCHER` property indicating the servlet filter is applied to client requests.
    `static java.lang.String` | `HTTP_WHITEBOARD_CONTEXT_INIT_PARAM_PREFIX` Service property prefix referencing a `ServletContextHelper` service.
    `static java.lang.String` | `HTTP_WHITEBOARD_CONTEXT_NAME` Service property specifying the name of an `ServletContextHelper` service.
    `static java.lang.String` | `HTTP_WHITEBOARD_CONTEXT_PATH` Service property specifying the path of an `ServletContextHelper` service.
    `static java.lang.String` | `HTTP_WHITEBOARD_CONTEXT_SELECT` Service property referencing a `ServletContextHelper` service.
    `static java.lang.String` | `HTTP_WHITEBOARD_DEFAULT_CONTEXT_NAME` The name of the default `ServletContextHelper`.
    `static java.lang.String` | `HTTP_WHITEBOARD_FILTER_ASYNC_SUPPORTED` Service property specifying whether a servlet `Filter` service supports asynchronous processing.
    `static java.lang.String` | `HTTP_WHITEBOARD_FILTER_DISPATCHER` Service property specifying the dispatcher handling of a servlet `Filter`.
    `static java.lang.String` | `HTTP_WHITEBOARD_FILTER_INIT_PARAM_PREFIX` Service property prefix referencing a `Filter` service.
    `static java.lang.String` | `HTTP_WHITEBOARD_FILTER_NAME` Service property specifying the servlet filter name of a `Filter` service.
    `static java.lang.String` | `HTTP_WHITEBOARD_FILTER_PATTERN` Service property specifying the request mappings for a `Filter` service.
    `static java.lang.String` | `HTTP_WHITEBOARD_FILTER_REGEX` Service property specifying the request mappings for a servlet `Filter` service.
    `static java.lang.String` | `HTTP_WHITEBOARD_FILTER_SERVLET` Service property specifying the `servlet names` for a servlet `Filter` service.
    `static java.lang.String` | `HTTP_WHITEBOARD_LISTENER` Service property to mark a Listener service as a Whiteboard service.
    `static java.lang.String` | `HTTP_WHITEBOARD_RESOURCE_PATTERN` Service property specifying the request mappings for resources.
    `static java.lang.String` | `HTTP_WHITEBOARD_RESOURCE_PREFIX` Service property specifying the resource entry prefix for a resource service.
    `static java.lang.String` | `HTTP_WHITEBOARD_SERVLET_ASYNC_SUPPORTED` Service property specifying whether a `Servlet` service supports asynchronous processing.
    `static java.lang.String` | `HTTP_WHITEBOARD_SERVLET_ERROR_PAGE` Service property specifying whether a `Servlet` service acts as an error page.
    `static java.lang.String` | `HTTP_WHITEBOARD_SERVLET_INIT_PARAM_PREFIX` Service property prefix referencing a `Servlet` service.
    `static java.lang.String` | `HTTP_WHITEBOARD_SERVLET_NAME` Service property specifying the servlet name of a `Servlet` service.
    `static java.lang.String` | `HTTP_WHITEBOARD_SERVLET_PATTERN` Service property specifying the request mappings for a `Servlet` service.
    `static java.lang.String` | `HTTP_WHITEBOARD_TARGET` Service property specifying the target filter to select the Http Whiteboard implementation to process the service.

  - ### Method Summary

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### HTTP_WHITEBOARD_CONTEXT_NAME

          public static final java.lang.String HTTP_WHITEBOARD_CONTEXT_NAME

      Service property specifying the name of an `ServletContextHelper` service.

      For `ServletContextHelper` services, this service property must be specified. Context services without this service property are ignored.

      Servlet, listener, servlet filter, and resource services might refer to a specific `ServletContextHelper` service referencing the name with the `HTTP_WHITEBOARD_CONTEXT_SELECT` property.

      For `ServletContextHelper` services, the value of this service property must be of type `String`. The value must follow the "symbolic-name" specification from Section 1.3.2 of the OSGi Core Specification.

      See Also:
        `HTTP_WHITEBOARD_CONTEXT_PATH`, `HTTP_WHITEBOARD_CONTEXT_SELECT`, `HTTP_WHITEBOARD_DEFAULT_CONTEXT_NAME`, Constant Field Values

    - #### HTTP_WHITEBOARD_DEFAULT_CONTEXT_NAME

          public static final java.lang.String HTTP_WHITEBOARD_DEFAULT_CONTEXT_NAME

      The name of the default `ServletContextHelper`. If a service is registered with this property, it is overriding the default context with a custom provided context.
      See Also:
        `HTTP_WHITEBOARD_CONTEXT_NAME`, Constant Field Values

    - #### HTTP_WHITEBOARD_CONTEXT_PATH

          public static final java.lang.String HTTP_WHITEBOARD_CONTEXT_PATH

      Service property specifying the path of an `ServletContextHelper` service.

      For `ServletContextHelper` services this service property is required. Context services without this service property are ignored.

      This property defines a context path under which all whiteboard services associated with this context are registered. Having different contexts with different paths allows to separate the URL space.

      For `ServletContextHelper` services, the value of this service property must be of type `String`. The value is either a slash for the root or it must start with a slash but not end with a slash. Valid characters are defined in rfc3986#section-3.3. Contexts with an invalid path are ignored.

      See Also:
        `HTTP_WHITEBOARD_CONTEXT_NAME`, `HTTP_WHITEBOARD_CONTEXT_SELECT`, Constant Field Values

    - #### HTTP_WHITEBOARD_CONTEXT_INIT_PARAM_PREFIX

          public static final java.lang.String HTTP_WHITEBOARD_CONTEXT_INIT_PARAM_PREFIX

      Service property prefix referencing a `ServletContextHelper` service.

      For `ServletContextHelper` services this prefix can be used for service properties to mark them as initialization parameters which can be retrieved from the associated servlet context. The prefix is removed from the service property name to build the initialization parameter name.

      For `ServletContextHelper` services, the value of each initialization parameter service property must be of type `String`.

      See Also:
        Constant Field Values

    - #### HTTP_WHITEBOARD_CONTEXT_SELECT

          public static final java.lang.String HTTP_WHITEBOARD_CONTEXT_SELECT

      Service property referencing a `ServletContextHelper` service.

      For servlet, listener, servlet filter, or resource services, this service property refers to the associated `ServletContextHelper` service. The value of this property is a filter expression which is matched against the service registration properties of the `ServletContextHelper` service. If this service property is not specified, the default context is used. If there is no context service matching, the servlet, listener, servlet filter, or resource service is ignored.

      For example, if a whiteboard service wants to select a servlet context helper with the name "Admin" the expression would be "(osgi.http.whiteboard.context.name=Admin)". Selecting all contexts could be done with "(osgi.http.whiteboard.context.name=*)".

      For servlet, listener, servlet filter, or resource services, the value of this service property must be of type `String`.

      See Also:
        `HTTP_WHITEBOARD_CONTEXT_NAME`, `HTTP_WHITEBOARD_CONTEXT_PATH`, Constant Field Values

    - #### HTTP_WHITEBOARD_SERVLET_NAME

          public static final java.lang.String HTTP_WHITEBOARD_SERVLET_NAME

      Service property specifying the servlet name of a `Servlet` service.

      This name is used as the value for the `ServletConfig.getServletName()` method. If this service property is not specified, the fully qualified name of the service object's class is used as the servlet name. Filter services may refer to servlets by this name in their `HTTP_WHITEBOARD_FILTER_SERVLET` service property to apply the filter to the servlet.

      Servlet names should be unique among all servlet services associated with a single `ServletContextHelper`.

      The value of this service property must be of type `String`.

      See Also:
        Constant Field Values

    - #### HTTP_WHITEBOARD_SERVLET_PATTERN

          public static final java.lang.String HTTP_WHITEBOARD_SERVLET_PATTERN

      Service property specifying the request mappings for a `Servlet` service.

      The specified patterns are used to determine whether a request should be mapped to the servlet. Servlet services without this service property or `HTTP_WHITEBOARD_SERVLET_ERROR_PAGE` are ignored.

      The value of this service property must be of type `String`, `String[]`, or `Collection<String>`.

      See Also:
        "Java Servlet Specification Version 3.0, Section 12.2 Specification of Mappings", Constant Field Values

    - #### HTTP_WHITEBOARD_SERVLET_ERROR_PAGE

          public static final java.lang.String HTTP_WHITEBOARD_SERVLET_ERROR_PAGE

      Service property specifying whether a `Servlet` service acts as an error page.

      The service property values may be the name of a fully qualified exception class, a three digit HTTP status code, the value "4xx" for all error codes in the 400 range, or the value "5xx" for all error codes in the 500 range. Any value that is not a three digit number, or one of the two special values is considered to be the name of a fully qualified exception class.

      The value of this service property must be of type `String`, `String[]`, or `Collection<String>`.

      See Also:
        Constant Field Values

    - #### HTTP_WHITEBOARD_SERVLET_ASYNC_SUPPORTED

          public static final java.lang.String HTTP_WHITEBOARD_SERVLET_ASYNC_SUPPORTED

      Service property specifying whether a `Servlet` service supports asynchronous processing.

      By default servlet services do not support asynchronous processing.

      The value of this service property must be of type `Boolean`.

      See Also:
        "Java Servlet Specification Version 3.0, Section 2.3.3.3 Asynchronous Processing", Constant Field Values

    - #### HTTP_WHITEBOARD_SERVLET_INIT_PARAM_PREFIX

          public static final java.lang.String HTTP_WHITEBOARD_SERVLET_INIT_PARAM_PREFIX

      Service property prefix referencing a `Servlet` service.

      For `Servlet` services this prefix can be used for service properties to mark them as initialization parameters which can be retrieved from the associated servlet config. The prefix is removed from the service property name to build the initialization parameter name.

      For `Servlet` services, the value of each initialization parameter service property must be of type `String`.

      See Also:
        Constant Field Values

    - #### HTTP_WHITEBOARD_FILTER_NAME

          public static final java.lang.String HTTP_WHITEBOARD_FILTER_NAME

      Service property specifying the servlet filter name of a `Filter` service.

      This name is used as the value for the `FilterConfig.getFilterName()` method. If this service property is not specified, the fully qualified name of the service object's class is used as the servlet filter name.

      Servlet filter names should be unique among all servlet filter services associated with a single `ServletContextHelper`.

      The value of this service property must be of type `String`.

      See Also:
        Constant Field Values

    - #### HTTP_WHITEBOARD_FILTER_PATTERN

          public static final java.lang.String HTTP_WHITEBOARD_FILTER_PATTERN

      Service property specifying the request mappings for a `Filter` service.

      The specified patterns are used to determine whether a request should be mapped to the servlet filter. Filter services without this service property or the `HTTP_WHITEBOARD_FILTER_SERVLET` or the `HTTP_WHITEBOARD_FILTER_REGEX` service property are ignored.

      The value of this service property must be of type `String`, `String[]`, or `Collection<String>`.

      See Also:
        "Java Servlet Specification Version 3.0, Section 12.2 Specification of Mappings", Constant Field Values

    - #### HTTP_WHITEBOARD_FILTER_SERVLET

          public static final java.lang.String HTTP_WHITEBOARD_FILTER_SERVLET

      Service property specifying the `servlet names` for a servlet `Filter` service.

      The specified names are used to determine the servlets whose requests should be mapped to the servlet filter. Servlet filter services without this service property or the `HTTP_WHITEBOARD_FILTER_PATTERN` or the `HTTP_WHITEBOARD_FILTER_REGEX` service property are ignored.

      The value of this service property must be of type `String`, `String[]`, or `Collection<String>`.

      See Also:
        Constant Field Values

    - #### HTTP_WHITEBOARD_FILTER_REGEX

          public static final java.lang.String HTTP_WHITEBOARD_FILTER_REGEX

      Service property specifying the request mappings for a servlet `Filter` service.

      The specified regular expressions are used to determine whether a request should be mapped to the servlet filter. The regular expressions must follow the syntax defined in `java.util.regex.Pattern`. Servlet filter services without this service property or the `HTTP_WHITEBOARD_FILTER_SERVLET` or the `HTTP_WHITEBOARD_FILTER_PATTERN` service property are ignored.

      The value of this service property must be of type `String`, `String[]`, or `Collection<String>`.

      See Also:
        "java.util.regex.Pattern", Constant Field Values

    - #### HTTP_WHITEBOARD_FILTER_ASYNC_SUPPORTED

          public static final java.lang.String HTTP_WHITEBOARD_FILTER_ASYNC_SUPPORTED

      Service property specifying whether a servlet `Filter` service supports asynchronous processing.

      By default servlet filters services do not support asynchronous processing.

      The value of this service property must be of type `Boolean`.

      See Also:
        "Java Servlet Specification Version 3.0, Section 2.3.3.3 Asynchronous Processing", Constant Field Values

    - #### HTTP_WHITEBOARD_FILTER_DISPATCHER

          public static final java.lang.String HTTP_WHITEBOARD_FILTER_DISPATCHER

      Service property specifying the dispatcher handling of a servlet `Filter`.

      By default servlet filter services are associated with client requests only (see value `DISPATCHER_REQUEST`).

      The value of this service property must be of type `String`, `String[]`, or `Collection<String>`. Allowed values are `DISPATCHER_ASYNC`, `DISPATCHER_ERROR`, `DISPATCHER_FORWARD`, `DISPATCHER_INCLUDE`, `DISPATCHER_REQUEST`.

      See Also:
        "Java Servlet Specification Version 3.0, Section 6.2.5 Filters and the RequestDispatcher", Constant Field Values

    - #### HTTP_WHITEBOARD_FILTER_INIT_PARAM_PREFIX

          public static final java.lang.String HTTP_WHITEBOARD_FILTER_INIT_PARAM_PREFIX

      Service property prefix referencing a `Filter` service.

      For `Filter` services this prefix can be used for service properties to mark them as initialization parameters which can be retrieved from the associated filter config. The prefix is removed from the service property name to build the initialization parameter name.

      For `Filter` services, the value of each initialization parameter service property must be of type `String`.

      See Also:
        Constant Field Values

    - #### HTTP_WHITEBOARD_LISTENER

          public static final java.lang.String HTTP_WHITEBOARD_LISTENER

      Service property to mark a Listener service as a Whiteboard service. Listener services with this property set to the string value "true" will be treated as Whiteboard services opting in to being handled by the Http Whiteboard implementation. If the value "false" is specified, the service is opting out and this case is treated exactly the same as if this property is missing. If an invalid value is specified this is treated as a failure.

      The value of this service property must be of type `String`. Valid values are "true" and "false" ignoring case.

      See Also:
        Constant Field Values

    - #### DISPATCHER_REQUEST

          public static final java.lang.String DISPATCHER_REQUEST

      Possible value for the `HTTP_WHITEBOARD_FILTER_DISPATCHER` property indicating the servlet filter is applied to client requests.
      See Also:
        "Java Servlet Specification Version 3.0, Section 6.2.5 Filters and the RequestDispatcher", Constant Field Values

    - #### DISPATCHER_INCLUDE

          public static final java.lang.String DISPATCHER_INCLUDE

      Possible value for the `HTTP_WHITEBOARD_FILTER_DISPATCHER` property indicating the servlet filter is applied to include calls to the dispatcher.
      See Also:
        "Java Servlet Specification Version 3.0, Section 6.2.5 Filters and the RequestDispatcher", Constant Field Values

    - #### DISPATCHER_FORWARD

          public static final java.lang.String DISPATCHER_FORWARD

      Possible value for the `HTTP_WHITEBOARD_FILTER_DISPATCHER` property indicating the servlet filter is applied to forward calls to the dispatcher.
      See Also:
        "Java Servlet Specification Version 3.0, Section 6.2.5 Filters and the RequestDispatcher", Constant Field Values

    - #### DISPATCHER_ASYNC

          public static final java.lang.String DISPATCHER_ASYNC

      Possible value for the `HTTP_WHITEBOARD_FILTER_DISPATCHER` property indicating the servlet filter is applied in the asynchronous context.
      See Also:
        "Java Servlet Specification Version 3.0, Section 6.2.5 Filters and the RequestDispatcher", Constant Field Values

    - #### DISPATCHER_ERROR

          public static final java.lang.String DISPATCHER_ERROR

      Possible value for the `HTTP_WHITEBOARD_FILTER_DISPATCHER` property indicating the servlet filter is applied when an error page is called.
      See Also:
        "Java Servlet Specification Version 3.0, Section 6.2.5 Filters and the RequestDispatcher", Constant Field Values

    - #### HTTP_WHITEBOARD_RESOURCE_PATTERN

          public static final java.lang.String HTTP_WHITEBOARD_RESOURCE_PATTERN

      Service property specifying the request mappings for resources.

      The specified patterns are used to determine whether a request should be mapped to resources. Resource services without this service property are ignored.

      The value of this service property must be of type `String`, `String[]`, or `Collection<String>`.

      See Also:
        "Java Servlet Specification Version 3.0, Section 12.2 Specification of Mappings", `HTTP_WHITEBOARD_RESOURCE_PREFIX`, Constant Field Values

    - #### HTTP_WHITEBOARD_RESOURCE_PREFIX

          public static final java.lang.String HTTP_WHITEBOARD_RESOURCE_PREFIX

      Service property specifying the resource entry prefix for a resource service.

      If a resource service is registered with this property, requests are served with bundle resources.

      This prefix is used to map a requested resource to the bundle's entries. The value must not end with slash ("/") with the exception that a name of the form "/" is used to denote the root of the bundle. See the specification text for details on how HTTP requests are mapped.

      The value of this service property must be of type `String`.

      See Also:
        `HTTP_WHITEBOARD_RESOURCE_PATTERN`, Constant Field Values

    - #### HTTP_WHITEBOARD_TARGET

          public static final java.lang.String HTTP_WHITEBOARD_TARGET

      Service property specifying the target filter to select the Http Whiteboard implementation to process the service.

      An Http Whiteboard implementation can define any number of service properties which can be referenced by the target filter. The service properties should always include the `osgi.http.endpoint` service property if the endpoint information is known.

      If this service property is not specified, then all Http Whiteboard implementations can process the service.

      The value of this service property must be of type `String` and be a valid `filter string`.

      See Also:
        Constant Field Values